#include "SerialManager.h"
#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"
#include "stdio.h"

struct SerialWriting COM8 = {0};

static void MakeSerial(USART_TypeDef *uart, u16 bufflen, struct SerialWriting* com);

void SerialWriter_Init()
{
    MakeSerial(UART8, 32, &COM8);
}

//串口写入线程
void SerialWriter_Thread(struct SerialWriting *com)
{
    while (1)
    {
        if (USART_GetFlagStatus(com->Uart, USART_FLAG_TC) == RESET)
            continue;
        //如果Buf中没有数据
        if (com->Len == 0)
        {
            if (!xQueueReceive(com->QueueHandle, com, 1000))
            {
                com->Len = 0;
                continue;
            }
            com->Index = 0;
        }
        USART_SendData(UART8, com->Data[com->Index]);
        com->Index++;
        //如果发送完了,清理发送完的Buf
        if (com->Index >= com->Len)
        {
            com->Len = 0;
            vPortFree(com->Data);
        }
    }
}

static void MakeSerial(USART_TypeDef *uart, u16 bufflen, struct SerialWriting* com)
{
    com->Len = 0;
    com->Uart = uart;
    com->QueueHandle = xQueueCreate(bufflen, sizeof(struct SerialPackBuf));
    return;
}

u8 SerialWriter_Send(struct SerialWriting* com, u8 *data, u32 len, u8 fromisr)
{
    struct SerialPackBuf spb = {0};
    spb.Data = pvPortMalloc(len);
    spb.Len = len;
    memcpy(spb.Data, data, len);
    if (fromisr)
    {
        xQueueSendFromISR(com->QueueHandle, &spb, 0);
    }
    else
    {
        xQueueSend(com->QueueHandle, &spb, 0);
    }
    return 1;
}

u8 SerialWriter_SendString(struct SerialWriting* com, u8 *data, u8 fromisr)
{
    return SerialWriter_Send(com,data,strlen(data),fromisr);
}
// */