
#ifndef DEVICES_SERIALMANAGER_H_
#define DEVICES_SERIALMANAGER_H_

#include "FreeRTOS.h"
#include "ch32v30x.h"
#include "task.h"
#include "queue.h"

struct SerialPackBuf
{
    u32 Len;
    u8* Data;
};

struct SerialWriting
{
    u32 Len;
    u8* Data;
    u32 Index;
    USART_TypeDef * Uart;
    
    QueueHandle_t QueueHandle;
    TaskHandle_t TaskHandle;
};

extern struct SerialWriting COM8;

void SerialWriter_Init();
void SerialWriter_Thread(struct SerialWriting *com);
u8 SerialWriter_Send(struct SerialWriting *com, u8 *data, u32 len, u8 fromisr);
#endif