/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : Main program body.
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/

/*
 *@Note
 task1 and task2 alternate printing
*/
#include "debug.h"
#include "FreeRTOS.h"
#include "task.h"
#include "main.h"
#include "SerialManager.h"

/* Global define */
/* Global Variable */
TaskHandle_t Task1Task_Handler;
TaskHandle_t Task2Task_Handler;

struct GasRecord SensorStatus={0}; 

void SystemInfo(void* none)
{
    while(1)
    {
	    PRINT("SystemClk:%d\r\n",SystemCoreClock);
        vTaskDelay(500);
	    PRINT("FreeRTOS Kernel Version:%s\r\n",tskKERNEL_VERSION_NUMBER);
        vTaskDelay(1000);
    }
}


/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);

	USART_Printf_Init(115200);
    SerialWriter_Init();
	//TIM1_PWMOut_Init( 6, 2-1, 3 );
    
    xTaskCreate(
        (TaskFunction_t)SerialWriter_Thread,
        (const char *)"SerialWriter_Thread",
        (uint16_t)64,
        (void *)&COM8,
        (UBaseType_t)1,
        (TaskHandle_t *)&(COM8.TaskHandle));
    xTaskCreate((TaskFunction_t )SystemInfo,
        (const char*    )"SystemInfo",
        (uint16_t       )64,
        (void*          )NULL,
        (UBaseType_t    )5,
        (TaskHandle_t*  )&Task2Task_Handler);
    vTaskStartScheduler();

	while(1)
	{
	    PRINT("shouldn't run at here!!\r\n");
	}
}
